/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Initialization and termination code                                    *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <ctype.h>
#include "prog.h"
#include "ffind.h"
#include "max.h"
#include "max_msg.h"
#include "dr.h"

extern int unum;/* Login temporary holding spot for user number in MAGN_LOG */

static void pascal Delete_Utask(void);
static void pascal Write_Utask(void);
static byte Assign_Unique_Task(void);

static char *utask="%sUTASK%02x.BBS",
            *ut_star="%sUTASK*.BBS",
            *ut_name="UTASK%02x.BBS";

void medinit(void);          
          
void pascal Init_Variables(void)
{
  int x;
  char *s;

  timestart=time(NULL);

  multitasker=-2;
  strcpy(log_name,c123);

  local_putc=(void (*)(int))fputchar;
  local_puts=(void (*)(char *))putss;

#ifdef OS_2
  setvbuf(stdout,NULL,_IOFBF,1024);
#endif

#ifndef ORACLE
  Lprintf(slogan,"\n",version,test);
  Lputs(copyright);
#endif

  *firstname=*linebuf=*searchfor=*fix_menupath=*last_readln='\0';

  display_line=display_col=current_line=current_col=1;

  port=-1;
  usernum=class=-1;
  orig_disk=orig_disk2=orig_disk3=-1;
  local=-2;
  task_num=-2;

  baud=0;
  current_baud=0;
  steady_baud=0;
  ultoday=nested=0;
  brk_trapped=0;
  erl=0;
  fnames=0;
  max_lines=0;
  rst_offset=-1L;

  menu_lines=1;

  if (getcwd(original_path,PATHLEN)==NULL)
  {
    Lputs(s(err_startup_tlong));
    Local_Beep(3);
    exit(ERROR_file);
  }
  else if (strlen(fancy_str(original_path)) > 3)
    strcat(fancy_str(original_path),"\\");

  if ((s=getenv("PROMPT")) != NULL)
  {
    if ((original_prompt=malloc(strlen(s)+1)) != NULL)
      strcpy(original_prompt,s);
    else original_prompt=NULL;
  }
  else original_prompt=NULL;

  memset(&laston,'\x00',sizeof(struct _stamp));
  memset(&area,'\x00',sizeof(struct _area));

  beginline=TRUE;

  snoop=keyboard=caller_online=do_timecheck=fossil_initd=realgoto=
    written_echomail=written_matrix=sent_time_5left=sent_time_almostup=
    topline=wrap=inmsgarea=infilearea=inmagnet=restart_system=first_search=
    last_nonstop=barricade_ok=create_userbbs=this_logon_bad=inchat=
    locked=locked2=chatreq=do_useredit=do_desqsnoop=fthru_yuhu=shutup=
    nowrite_lastuser=in_file_xfer=written_local=mn_dirty=no_zmodem=
    in_mcheck=no_shell=dsp_set=no_piggy=FALSE;

  direction=DIRECTION_next;

  offsets=NULL;
  msgs=NULL;
  chatlog=NULL;
  filenames[0]=NULL;

  max_time=0xffffL;
  last_bps=0;

  displaymode=VIDEO_dos;

  prm.logon_priv=TWIT;
  Blank_User(&usr);

  for (x=0;x < MAX_DRIVES;x++)
    orig_path[x]=orig_path2[x]=orig_path3[x]=NULL;

  memset(echo_written_in,'\x00',sizeof(echo_written_in));
}


#ifndef ORACLE

void pascal Parse_Args(char *ctlname,int argc,char *argv[])
{
  int x;

  char *p1,
       *p2;

  for (x=1;x < argc;x++)
    Parse_Single_Arg(argv[x]);

  p1=strrchr(prmname,'.');
  p2=strrchr(prmname,'\\');

  if (p2==NULL)
    p2=strrchr(prmname,'/');

  if (p1)             /* There might be an extension */
  {
    if (p2)           /* There IS a path */
    {
      if (p2 < p1)    /* Path delim was BEFORE the '.', so it must be extension */
        *p1='\0';
    }
    else *p1='\0';    /* No path, so chop it off */
  }

  strcpy(ctlname,fancy_str(prmname));
  strcat(ctlname,".Ctl");
  strcat(prmname,".Prm");
}


void pascal Parse_Single_Arg(char *arg)
{
  if (*arg=='-' || *arg=='/')
  {
    strlwr(arg);

    switch(arg[1])
    {
      case 'b':             /* Baud rate select */
        local=FALSE;
        baud=atol(arg+2);
        current_baud=Decimal_Baud_To_Mask((unsigned int)baud);
        break;

      case 'c':             /* Create USER.BBS if doesn't already exist */
        create_userbbs=TRUE;
        break;

      case 'j':             /* JAM in command */
        strcpy(linebuf,arg+2);
        break;

      case 'k':             /* Local mode */
        baud=0;
        current_baud=0;
        local=TRUE;
        break;

      case 'l':             /* Log file */
        strcpy(log_name,arg+2);
        break;

      case 'm':             /* Multitasker */
        switch (arg[2])
        {
          case 'd':         /* DoubleDOS */
            multitasker=MULTITASKER_doubledos;
            break;

          case 'q':         /* DesqView */
            multitasker=MULTITASKER_desqview;
            break;

          case 'p':         /* TopView */
            multitasker=MULTITASKER_topview;
            break;

          case 't':         /* TaskView */
            multitasker=MULTITASKER_taskview;
            break;

          case 'w':          /* MS-Windows */
            multitasker=MULTITASKER_mswindows;
            break;

          case 'm':         /* PC-MOS */
            multitasker=MULTITASKER_pcmos;
            break;

          case 'n':         /* No multitasker */
            multitasker=MULTITASKER_none;
            break;

          default:
            Unknown_CmdParam(arg);
        }
        break;

      case 'n':
        task_num=(char)atoi(arg+2);
        break;

      case 'p':             /* COM: port */
        port=atoi(arg+2);

#ifndef OS_2
        if (port==0 || port > 8)
          Unknown_CmdParam(arg);
#endif


        port--;
        break;
        
      case 'q':             /* Unique task assignment */
        unique_task=TRUE;
        break;

      case 'r':             /* Restart with logged-in caller still online! */
        restart_system=TRUE;
        break;
        
      case 's':
        steady_baud=Decimal_Baud_To_Mask((unsigned int)atol(arg+2));
        break;

      case 't':             /* Max. time left */
        max_time=atol(arg+2);
        break;

      case 'u':             /* Auto user-editor */
        do_useredit=TRUE;

        if (arg[2]=='h')
        {
          usr.help=HOTFLASH;
          usr.bits |= BITS_hotkeys;
        }
        else if (arg[2]=='q')
          usr.bits |= BITS_hotkeys;
        else usr.help=NOVICE;

        break;

      case 'x':
        switch (tolower(arg[2]))
        {
          case 'z':
            no_zmodem=TRUE;
            break;

          case 'j':
            no_shell=TRUE;
            break;

          case 'p':
            no_piggy=TRUE;
            break;

          default:
            Unknown_CmdParam(arg);
        }
        break;

      case 'z':
#if defined(OS_2)
        SnSetPipeName(arg+2);
#elif defined(DESQSNOOP)
        do_desqsnoop=TRUE;
#endif
        break;

      default:
        Unknown_CmdParam(arg);
        break;
    }
  }
  else strcpy(prmname,arg);
}



void pascal Unknown_CmdParam(char *param)
{
  Lprintf(huh,param);
  quit(ERROR_param);
}

#endif /* !ORACLE */



void pascal Startup(void)
{
  int fd;

  char temp[PATHLEN];

  struct _usr user;

  if (task_num==-2)
    task_num=prm.task_num;

#ifdef OS_2
  multitasker=MULTITASKER_os2;
#else

  if (multitasker==-2)
    multitasker=prm.multitasker;

  switch (multitasker)
  {
    case MULTITASKER_doubledos:

      /* If we've selected DDOS as our multitasker, make a call to        *
       * make sure that it *is* actually here, since we'll lock up        *
       * tight when we call Giveaway_Slice(), if we enabled it in the     *
       * CTL file, but forgot to load DDOS itself.                        */


      if (! DdosInstalled())   /* If it's not there... */
      {
        #ifndef ORACLE
        Lputs(s(ddwarn));
        #endif

        multitasker=0;      /* ...then zero out M'task field! */
      }
      break;
  }

#endif /* !OS_2 */

  if (!restart_system)
    ChatCleanUp();

  if (port==-1)
    port=prm.com_port;

  if (local==-2)
    local=(char)((prm.flags & FLAG_keyboard) != FALSE);

  if (baud==0)
    local=TRUE;

  if (local)
    port=0xff;
  else if (port==-1 || port==0xff)
    port=0;

  snoop=(char)(prm.flags & FLAG_snoop);

  if (!dsp_set)
    displaymode=prm.video;
  
  switch (displaymode)
  {
    case VIDEO_fossil:

#ifndef ORACLE       /* ORACLE doesn't use the fossil -- just fall thru to  *
                      * DOS video, if that's the mode we've specified.      */
      local_putc=(void (*)(int))fossil_putc;
      local_puts=(void (*)(char *))fossil_puts;
      break;
#endif

    case VIDEO_dos:
      local_putc=(void (*)(int))fputchar;
      local_puts=(void (*)(char *))putss;
      break;

    case VIDEO_fast:
#ifndef OS_2
      local_putc=(void (*)(int))xputch;
      local_puts=(void (*)(char *))xputs;
      break;
#endif  /* else fall through...*/

    case VIDEO_ibm:
      VidOpen(prm.flags2 & FLAG2_has_snow,multitasker==MULTITASKER_desqview,
              prm.flags & FLAG_statusline);

      local_putc=(void (*)(int))VidPutc;
      local_puts=(void (*)(char *))VidPuts;
      break;
  }

  Lputs(GRAY);

  if (*PRM(first_menu))
  {
    strncpy(main_menu,PRM(first_menu),MAX_MENUNAME-1);
    main_menu[MAX_MENUNAME-1]='\0';
  }
  else strcpy(main_menu,"MAIN");

  if (*PRM(menupath))
    strcpy(menupath,PRM(menupath));
  else strcpy(menupath,PRM(sys_path));

  timeon=time(NULL);              /* Initalize time on/off counters */

#ifndef ORACLE

  if (do_useredit)
  {
    usr.ansi=1;
    usr.formfeed=1;
    usr.width=80;
    usr.len=25;

    timeoff=timeon+(1440*60L);
    usernum=-1;

    local=TRUE;

    if ((areasfile=shopen(PRM(adat_name),O_RDONLY | O_BINARY))==-1)
    {
      logit(cantopen_crit,PRM(adat_name));
      Local_Beep(3);
      exit(ERROR_file);
    }

    if ((areasidx=shopen(PRM(aidx_name),O_RDONLY | O_BINARY))==-1)
    {
      logit(cantopen_crit,PRM(aidx_name));
      Local_Beep(3);
      exit(ERROR_file);
    }

    mknl(log_name);

    Fossil_Install();
    User_Edit();

    close(areasidx);
    close(areasfile);

    vbuf_flush();

    if (displaymode==VIDEO_ibm)
      VidClose(multitasker==MULTITASKER_desqview);

    quit(0);
  }
  
#endif /* !ORACLE */
  
  Calc_Timeoff();

  do_timecheck=TRUE;

#ifndef ORACLE

  if (eqstr(log_name,c123)) /* No cmd-line param */
    strcpy(log_name,PRM(log_name));

  if (log_name && !isnl(log_name))  /* If we have a valid log name */
  {
    if (! LogOpen())
      quit(ERROR_critical);
  }

  if ((areasfile=shopen(PRM(adat_name),O_RDONLY | O_BINARY))==-1)
  {
    logit(cantopen_crit,PRM(adat_name));
    Local_Beep(3);
    exit(ERROR_file);
  }

  if ((areasidx=shopen(PRM(aidx_name),O_RDONLY | O_BINARY))==-1)
  {
    logit(cantopen_crit,PRM(aidx_name));
    Local_Beep(3);
    exit(ERROR_file);
  }

  if (!restart_system)
  {
    if (unique_task)
      task_num=Assign_Unique_Task();

    Write_Utask();
    
    if (task_num)
      logit(s(log_begin_mt),version,task_num);
    else logit(s(log_begin_1t),version);

    logit(" %s",PRM(system_name));

    sprintf(temp,activexx_bbs,original_path,task_num);

    if (fexist(temp))
    {
      unlink(temp);

      if (task_num)
        sprintf(temp,lastusxx_bbs,original_path,task_num);
      else sprintf(temp,lastuser_bbs,original_path);

      if ((fd=shopen(temp,O_RDONLY | O_BINARY)) != -1)
      {
        read(fd,(char *)&user,sizeof(struct _usr));
        close(fd);

        logit(s(log_syscrash1),task_num);
        logit(s(log_syscrash2),user.name);
      }
    }

    Fossil_Install();
  }


#ifndef OS_2
  zfree("");    /* Calculate free disk space here, so we don't have a long *
                 * pause later down the road...  Not needed for OS/2.      */
#else

  /* Install exception handler after Fossil_Install() and LogOpen()
   * so that snserver.dll and comm.dll install their DosExitList()
   * rutines before we do.  This ensures that our cleanup routine
   * occurs first,  so that we can still use functions exported
   * by those dlls.
   */

  medinit();

#endif /* OS_2 */

#endif /* !ORACLE */
}


/* Reads in the xx.PRM file, compares dates between that and the .CTL, etc */

void pascal Read_Prm(char *ctlname)
{
  int prmfile,
      x;

#ifndef ORACLE
  Compare_Dates(ctlname,prmname);
#endif

  if ((prmfile=shopen(prmname,O_RDONLY | O_BINARY))==-1)
  {
    Lprintf(cantfind+1,prmname);
    quit(ERROR_file);
  }

  x=read(prmfile,(char *)&prm,sizeof(struct m_pointers));

  if (prm.id != 'M' || prm.version != CTL_VER)
  {
    Lputs(s(inv_prm_ver));
    Local_Beep(3);
    quit(ERROR_file);
  }

  x=(int)(fsize(prmname)-((int)tell(prmfile)));
  offsets=(char *)malloc(x);
  x=read(prmfile,offsets,x);
  close(prmfile);

  /* Turn off the status line for local mode.  If restart_system is set,   *
   * then we won't know if the user is local or remote until we've read    *
   * in RESTARxx.BBS, so we'll take care of it in the System_Restart()     *
   * function in that case.                                                */

  if (local && !restart_system)
    prm.flags &= ~FLAG_statusline;
}


/* If the date of the .CTL file is greater than that of the .PRM, then
   make a ruckus! */

#ifndef ORACLE

void pascal Compare_Dates(char *ctlname,char *prmname)
{
  union stamp_combo st_c,
                    st_p;

  int ctlfile,
      prmfile;

  if ((ctlfile=shopen(ctlname,O_RDONLY))==-1)
    return;

  if ((prmfile=shopen(prmname,O_RDONLY))==-1)
    return;

  get_fdt(ctlfile,&st_c);
  get_fdt(prmfile,&st_p);

  close(ctlfile);
  close(prmfile);

  if (! GEdate(&st_p,&st_c))
  {
    Lputs(s(old_prm_ver));
    Local_Beep(3);
  }
}



int pascal Read_Stats(struct _bbs_stats *bstats)
{
  int bfile;

  char temp[PATHLEN];

  sprintf(temp,bbs_stats,PRM(sys_path),task_num);

  if ((bfile=shopen(temp,O_RDONLY | O_BINARY)) != -1)
  {
    read(bfile,(char *)bstats,sizeof(struct _bbs_stats));
    close(bfile);
  }

  if (bfile==-1 || bstats->version != STATS_VER)
  {
    memset(bstats,'\x00',sizeof(struct _bbs_stats));

    bstats->version=STATS_VER;
    bstats->online_date=time(NULL);
  }

  return 0;
}


void pascal Write_Stats(struct _bbs_stats *bstats)
{
  int bfile;

  char temp[PATHLEN];

  sprintf(temp,bbs_stats,PRM(sys_path),task_num);

  if ((bfile=sopen(temp,O_CREAT | O_TRUNC | O_WRONLY | O_BINARY,SH_DENYNONE,S_IREAD | S_IWRITE))==-1)
  {
    logit(cantopen,temp);
    return;
  }

  write(bfile,(char *)bstats,sizeof(struct _bbs_stats));
  close(bfile);
}

#endif


void pascal mdm_hangup(void)  /* Do the raise DTR/drop DTR thingy */
{
  long flush_tout;

  if (!local)
  {
    /* Turn off flow control so we don't get stuck with a ^s! */
    Mdm_Flow_Off();

#ifdef OS_2
    if(ComIsOnline(hcModem))
        ComTxWait(hcModem, 10000L);
    ComWatchDog(hcModem, FALSE, 0);
    ComPurge(hcModem, COMM_PURGE_ALL);
#endif

    /* Set a time limit anyway, just in case FOSSIL is brain-dead and      *
     * ignores instructions.                                               */

    flush_tout=timerset(1500);

    while (! out_empty() && !timeup(flush_tout))
      Giveaway_Slice();

    mdm_dump(DUMP_output);
    mdm_dtr(DTR_down);

    Delay(250);
    mdm_dtr(DTR_up);
  }

  quit(0);
}

#ifdef OS_2
extern void medfini(void);
#endif

void pascal quit(int el) /* A substitute for exit, it exits with error code <erl> */
{             /* only if erl > 0. (Typically used for an ERROR exit
                 condition.)  If the errorlevel IS zero, then we check
                 all of the flags to find out if the user wrote a matrix
                 or echomail message, and then exit with the appropriate
                 errorlevel.                                               */

  if (el)
    erl=(char)el;
  else if (usernum==-1)
    erl=ERROR_recycle;
  else if (written_echomail && prm.echo_exit)
    erl=prm.echo_exit;
  else if (written_matrix && prm.edit_exit)
    erl=prm.edit_exit;
  else if (written_local && prm.local_exit)
    erl=prm.local_exit;
  else if (prm.exit_val)  /* If we have a specific el for after each caller */
    erl=prm.exit_val;
  else erl=ERROR_recycle;

#ifdef OS_2
  medfini();
#endif

  exit(erl);
}



#ifndef ORACLE

/* This routine is called by FinishUp(), which just acts as a gateway for  *
 * this overlaid function.                                                 *
 *                                                                         *
 * This cleans up everything, closes files, updates the user's             *
 * entry in USER.BBS and LASTUSER.BBS, puts the modem on-hook, restores    *
 * the current directory, and writes the echo tosslog.                     */

void pascal FinishUp2(int hangup)
{
  FILE *fptr;

  char temp[PATHLEN];

  int x,y;

  caller_online=FALSE;

  /* Turn off flow control so we don't hang! */
  Mdm_Flow(FLOW_off);

#ifdef OS_2
  ComWatchDog(hcModem, FALSE, 0);
  ComPurge(hcModem, COMM_PURGE_ALL);
#endif

  if (!local && carrier())
  {
    mdm_fflush();
    mdm_dump(DUMP_input);
  }

  Lputs(GRAY);

  Restore_Directories3();
  Restore_Directories2();
  Restore_Directories();

  if (inmsgarea || infilearea)
    Last_Other();

  if (this_logon_bad)
    usr.bad_logon=TRUE;

  if (hangup)
  {
    Lputc('\n');

    if (usernum != -1 && rst_offset==-1L)
      logit(s(log_user_off_line),
            *usr.name ? usr.name : s(user_text),usr.times,timeonline(),
            usr.time+timeonline());
  }

  if (locked2)
  {
    locked2=FALSE;
    usr.priv=lockpriv2;
  }

  if (locked)
  {
    locked=FALSE;
    usr.priv=lockpriv;
  }

  if (usernum != -1)
  {
    strcpy(usr.ldate,next_ldate);

    if (!nowrite_lastuser)
      Write_LastUser();
  }

  usr.time += timeonline();

  if (this_logon_bad)
    usernum=unum;

  if (usernum != -1 && !nowrite_lastuser)
    Write_User(&usr,usernum);

  Write_Stats(&bstats);

  if (hangup && rst_offset==-1L)
    ChatCleanUp();

  if (hangup && !nowrite_lastuser)
  {
    /* Write the echo tosslog, if necessary... */

    if (prm.flags & FLAG_log_echo)
    {
      y=FALSE;

      if ((fptr=shfopen(PRM(echotoss_name),fopen_append,O_WRONLY | O_APPEND)) != NULL)
      {
        for (x=0;x < MAX_AREAS;x++)
          if (IsBit(echo_written_in,x))
          {
            y=TRUE;
            lseek(areasfile,(long)x*sizeof(struct _area),SEEK_SET);
            read(areasfile,(char *)&area,sizeof(struct _area));
            fprintf(fptr,"%s\n",area.msgname);
          }

        fclose(fptr);

        /* If we didn't write anything, and file is empty */
        if (!y && fsize(PRM(echotoss_name))==0L)
          unlink(PRM(echotoss_name));

      }
      else logit(cantopen,PRM(echotoss_name));
    }
  }

  if (rst_offset==-1L)
  {
    Delete_Utask();
    sprintf(temp,activexx_bbs,original_path,task_num);
    unlink(temp);
  }

  if (chatlog)
    Close_Chatlog();

  if (hangup && rst_offset==-1L)
  {
    logit(s(log_max_end),version,erl);
    LogWrite("\n");
  }

  LogClose();

  if (areasfile != -1)
    close(areasfile);

  if (areasidx != -1)
    close(areasidx);

  if (fossil_initd && rst_offset==-1L)
  {
    if (!local)
    {
      mdm_baud((char)Decimal_Baud_To_Mask(prm.max_baud));
      mdm_cmd(PRM(m_busy));
    }

    mdm_deinit();

    fossil_initd=FALSE;
  }

  sfree(offsets);
  sfree(original_prompt);

  Lputs(GRAY);

  if (displaymode==VIDEO_ibm)
  {
    if (prm.flags & FLAG_statusline)
      Draw_StatusLine(STATUS_remove);

    VidClose(multitasker==MULTITASKER_desqview);
  }
}


/* Write user number `unum' from the structure pointed to by `user' */
void pascal Write_User(struct _usr *user,int unum)
{
  int userbbs,
      x;

  for (x=0;x < MAX_BUSYLOOP;x++)
  {
    if ((userbbs=sopen(PRM(user_file),O_CREAT | O_WRONLY | O_BINARY,SH_DENYNONE,S_IREAD | S_IWRITE)) != -1)
      break;
  }

  if (userbbs==-1)
  {
    logit(cantopen_crit,PRM(user_file));
    Local_Beep(3);
    return;
  }

  lseek(userbbs,(long)unum*sizeof(struct _usr),SEEK_SET);
  write(userbbs,(char *)user,sizeof(struct _usr));

  close(userbbs);
}


unsigned int pascal Decimal_Baud_To_Mask(unsigned int bd)
{
  switch (bd)
  {
    case 300:
      return BAUD300;

    case 600:
      return BAUD600;

    case 1200:
      return BAUD1200;

    case 2400:
      return BAUD2400;

    case 4800:
      return BAUD4800;

    case 9600:
      return BAUD9600;

    case 19200:
      return BAUD19200;

    case 38400u:
      return BAUD38400;

    default:
      return 0;
  }
}



int pascal System_Restart(char *restart_name)
{
  struct _restart rst;

  char temp[PATHLEN];

  int userfile;

  /* Read the LASTUSER info */

  if (task_num)
    sprintf(temp,lastusxx_bbs,original_path,task_num);
  else sprintf(temp,lastuser_bbs,original_path);

  if ((userfile=shopen(temp,O_RDONLY | O_BINARY))==-1)
  {
    logit(cantopen_crit,temp);
    quit(ERROR_file);
  }

  read(userfile,(char *)&usr,sizeof(struct _usr));
  close(userfile);


  /* And now read the system restart info */

  sprintf(temp,restarxx_bbs,original_path,task_num);

  if ((userfile=shopen(temp,O_RDONLY | O_BINARY))==-1)
  {
    logit(cantopen,temp);
    quit(ERROR_file);
  }

  read(userfile,(char *)&rst,sizeof(struct _restart));
  close(userfile);

  /* Delete it, now that we have it */
  unlink(temp);

  strcpy(restart_name,rst.restart_name);
  strcpy(menupath,rst.menupath);
  strcpy(main_menu,rst.menuname);
  strcpy(firstname,rst.firstname);
  strcpy(next_ldate,rst.next_ldate);
  strcpy(last_onexit,rst.last_onexit);

  strcpy(fix_menupath,rst.fix_menupath);
  strcpy(last_name,rst.last_name);

  mn_dirty=rst.mn_dirty;


  lastmenu=rst.lastmenu;
  local=rst.local;
  port=rst.port;
  snoop=rst.snoop;
  keyboard=rst.keyboard;
  protocol_letter=rst.protocol_letter;
  chatreq=rst.chatreq;

  timeon=rst.timeon;
  timeoff=rst.timeoff;
  timestart=rst.timestart;
  rst_offset=rst.restart_offset;

  usr.time=rst.usr_time;
  usernum=rst.usernum;
  ultoday=rst.ultoday;

  locked=rst.locked;
  locked2=rst.locked2;

  lockpriv=rst.lockpriv;
  lockpriv2=rst.lockpriv2;

  written_echomail=rst.written_echomail;
  written_matrix=rst.written_matrix;

  current_baud=rst.current_baud;
  baud=rst.baud;
  max_time=rst.max_time;
  laston.msg_st=rst.laston;
  barricade_ok=rst.barricade_ok;
  area=rst.area;

  ChatRestoreStatus(&rst.css);

  memcpy(echo_written_in,rst.echo_written_in,sizeof(echo_written_in));

  caller_online=TRUE;

  /* Do this check for the status line here...  We couldn't do so          *
   * previously, since we didn't figure out whether or not the user was    *
   * local or not until now.                                               */

  if (local)
    prm.flags &= ~FLAG_statusline;

  /* Validate settings, and find class number */

  Validate_Runtime_Settings();

  Fossil_Install();

  if (! local)
    mdm_baud((char)current_baud);

  logit(s(log_ret_from_app));

  if (rst.ctltype != CTL_none)
    Read_External_Log(rst.ctltype,rst.parm,rst.starttime,OUTSIDE_errorlevel);

  return rst.restart_type;
}


void pascal Fossil_Install(void)
{
  if (mdm_init(local ? 0xff : port)==INIT_nofossil)
  {
    logit(s(log_no_fossil));
    quit(ERROR_nofossil);
  }

  fossil_initd=TRUE;

  Mdm_Flow_On();
}


void pascal Got_A_Null_Pointer(void)
{
  Restore_Directories();

  logit(s(log_got_null_ptr));

  Puts(s(found_nptr));

  LogClose();

  if (fossil_initd && rst_offset==-1L)
  {
    if (!local)
    {
      mdm_baud(Decimal_Baud_To_Mask(prm.max_baud));
      mdm_cmd(PRM(m_busy));
    }

    mdm_deinit();

    fossil_initd=FALSE;
  }

  if (did_trap)
    brkuntrap();

  _exit(16);
}


static byte Assign_Unique_Task(void)
{
  FFIND *ff;
  
  char temp[PATHLEN];
  
  int high=0,
      ret,
      x;
  
  sprintf(temp,ut_star,original_path);
  
  for (ff=FindOpen(temp,0),ret=0;ff && ret==0;ret=FindNext(ff))
  {
    if ((sscanf(ff->ff_name,ut_name,&x))==1)
      if (x > high)
        high=x;
  }
  
  if (++high >= 255)  /* Return error if there are too many task numbers */
    return -1;
  else return (byte)high;
}


static void pascal Write_Utask(void)
{
  char temp[PATHLEN];
  int fd;
  
  sprintf(temp,utask,original_path,task_num);
  
  if ((fd=shopen(temp,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY)) != -1)
    close(fd);
}

static void pascal Delete_Utask(void)
{
  char temp[PATHLEN];
  
  sprintf(temp,utask,original_path,task_num);
  unlink(temp);
}


#endif /* !ORACLE */


#ifndef SHORT_MDM_CMD
static char *mdm_rsp[]={"NO CARRIER",
                        "CONNECT",
                        "BUSY",
                        "VOICE",
                        "RING",
                        "RRING",
                        "RINGING",
                        "NO DIALTONE",
                        "NO DIAL TONE",
                        "DIAL TONE",
                        "ERROR",
                        "OK",
                        NULL};
#endif

int pascal mdm_cmd(char *command)
{
  #ifndef SHORT_MDM_CMD
  timer_t expire;

  unsigned int baud,
               y,z;

  int ch,
      buflen;

  char buffer[MAX_cmdlen],
       temp[50];

  MDM_RESPONSE retval;
  #endif


  unsigned int x;


  for (x=0;x < strlen(command);x++)
  {
    switch(command[x])
    {
      case '^':
        mdm_fflush();
        mdm_dtr(DTR_up);
        break;

      case 'v':
        mdm_fflush();
        mdm_dtr(DTR_down);
        break;

      case '~':
        mdm_fflush();
        Delay(100);
        break;

      case '`':
        mdm_fflush();
        Delay(5);
        break;

      case '|':
        mdm_pputcw('\x0d');
        break;

      default:
        mdm_pputcw(command[x]);
        break;
    }

    Delay(1);
  }

  #ifdef SHORT_MDM_CMD

  return MDM_ok;

  #else

  retval=MDM_none;

  expire=timerset(500);

  while (retval==MDM_none)
  {
    for (buflen=ch=0;(retval==MDM_none) && (ch != '\r');)
    {
      if (timeup(expire))
        retval=MDM_timeout;
      else if (mdm_avail)
      {
        if (buflen >= MAX_cmdlen)
          retval=-1;
        else
        {
          buffer[buflen++]=ch=mdm_getc();

          if ((ch=='\n') || ((buflen==1) && (ch=='\r')))
          {
            buflen--;
            ch=0;
          }
        }
      }
      else Giveaway_Slice();
    }

    if (retval==MDM_none)
    {
      buffer[--buflen]='\0';

      if (! stricmp(buffer,command))
        continue;

      x=stricmpm(buffer,mdm_rsp,0xffff);

      for (z=0,y=1;z < 16;y = y << 1,z++)
        if (x & y)
          break;

      switch (z)
      {
        case 0: /* no carrier */
          retval=MDM_nocarrier;
          break;

        case 1: /* connect */
          getword(buffer,temp," \t\n",2);
          baud=atoi(temp);

          switch(baud)
          {
            case 0:
            case 300:
              retval=MDM_connect3;
              break;

            case 600:
              retval=MDM_connect6;
              break;

            case 1200:
              retval=MDM_connect12;
              break;

            case 2400:
              retval=MDM_connect24;
              break;

            case 4800:
              retval=MDM_connect48;
              break;

            case 9600:
              retval=MDM_connect96;
              break;

            case 19200:
              retval=MDM_connect19;
              break;

            case 38400u:
              retval=MDM_connect38;
              break;

            default:
              retval=MDM_error;
              break;
          }
          break;

        case 2: /* busy */
          retval=MDM_busy;
          break;

        case 3: /* voice */
          retval=MDM_voice;
          break;

        case 4: /* ring */
          retval=MDM_ring;
          break;

        case 7: /* no dialtone */
        case 8: /* no dial tone */
          retval=MDM_nodialtone;
          break;

        case 9: /* dial tone */
          retval=MDM_dialtone;
          break;

        case 10: /* error */
          retval=MDM_error;
          break;

        case 11: /* ok */
          retval=MDM_ok;
          break;

        case 65535u:  /* anything else */
        case 5:       /* rring */
        case 6:       /* ringing */
          break;
      }
    }
  }

  mdm_dump(DUMP_input);
  return retval;

  #endif
}


